/* ========================================
 *  Distance - Distance.h
 *  Created 8/12/11 by SPIAdmin 
 *  Copyright (c) 2011 __MyCompanyName__, Airwindows uses the MIT license
 * ======================================== */

#ifndef __Distance_Distance_H
#define __Distance_Distance_H

#include "../../../configuration.h"
#ifdef SHR3D_SFX_CORE_AIRWINDOWS

#include "../common/airwin_consolidated_base.h"


namespace airwinconsolidated::Distance {
enum {
	kParamA = 0,
	kParamB = 1,
	kNumParameters = 2
}; //


class Distance final : public SfxCoreExtensionV1
{
public:
    Distance();
    ~Distance();
    void processBlock(float** inputs, float** outputs, int sampleFrames) override;
    int getParameterCount() const override;
    float getParameter(int index) override;
    void setParameter(int index, float value) override;
    void getParameterLabel(int index, char *text) override;
    void getParameterName(int index, char *text) override;
    void getParameterDisplay(int index, char *text) override;
private:
    
	double lastclampL;
	double clampL;
	double changeL;
	double thirdresultL;
	double prevresultL;
	double lastL;

	double lastclampR;
	double clampR;
	double changeR;
	double thirdresultR;
	double prevresultR;
	double lastR;
	
	uint32_t fpdL;
	uint32_t fpdR;
	//default stuff

    float A;
    float B;
};

} // end namespace

#endif // SHR3D_SFX_CORE_AIRWINDOWS

#endif
